; Various macros to do repetitive stuff that needs to be done in the eggdoc.

(define-syntax wiki
  (syntax-rules ()
   ((wiki)
     '((dt "wiki")
       (dd "The full URL of the API page of the wiki.  If not given,"
         " the value of the default-wiki parameter will be assumed")))))

(define-syntax method
  (syntax-rules ()
    ((method)
     '((dt "method")
       (dd "POST or GET.  If not given the value of the default-method"
           " parameter will be assumed.") ))))

(define-syntax source
  (syntax-rules ()
    ((source)
     '((dt "source")
       (dd "A source of pages on which to operate.  May be a string containing either"
           " a single titles or a list of titles separated by pipe (\"|\") characters,"
           " or may be a list of strings containing titles, or the output of another"
           " query module used as a generator.")))))

(define-syntax title
  (syntax-rules ()
    ((title)
     '((dt "title")
       (dd "The title of a single page about which this query is related.")))))

(define-syntax wiki-method
  (syntax-rules ()
    ((wiki-method)
    (list (wiki) (method)))))

(define-syntax wiki-method-warning
  (syntax-rules ()
    ((wiki-method-warning)
    (list (wiki) (method-warning)))))

(define-syntax start-end
  (syntax-rules ()
    ((start-end)
     '((dt "start")(dd "Timestamp to start listing from")
       (dt "end")(dd "Timestamp to stop listing at")))))

(define-syntax start-end-dir
  (syntax-rules ()
    ((start-end-dir)
     (append (start-end)
             '((dt "dir")(dd "The direction in which to list: older (default) or newer"))))))
(define-syntax namespace
  (syntax-rules ()
    ((namespace)
     '((dt "namespace")(dd "Only list pages in these namespaces")))))

(define-syntax filterredir
  (syntax-rules ()
    ((filterredir)
     '((dt "filterredir")
       (dd "How to filter redirects (one of the following:"
           "\"all\", \"redirects\",  \"nonredirects\").  Default"
           " is \"all\".")))))

(define-syntax from-prefix
  (syntax-rules ()
    ((from-prefix)
     '((dt "from")(dd "Start listing alphabetically from this point.")
       (dt "prefix")(dd "List only pages with this prefix")))))

(define-syntax namespace1
  (syntax-rules ()
    ((namespace1)
     '((dt "namespace")(dd "List only titles in this namespace")))))

(define-syntax boolean
  (syntax-rules ()
    ((_ x ...)
    (string-append "If present and not #f, " x ...))))
